#ifndef _POSIX_THREAD_H
#define _POSIX_THREAD_H


#include </usr/include/pthread.h>
#include <sys/types.h>


#define THREAD_IDLE     0
#define THREAD_RUNNING  1
#define THREAD_DEAD     2
#define THREAD_GCR      3

class POSIXThread
{
   public:

    POSIXThread();
    virtual ~POSIXThread(){};


    bool operator == (const POSIXThread& obj) const;
    bool operator != (const POSIXThread& obj) const;


    bool  start(bool thread_join = false);
    bool  setThreadState(int state);
    int   getThreadState();
    void  terminate();
    void  exit();
    int   self() const;

    int     join(void);
    virtual void collectFinalStats()=0;

   protected:

    POSIXThread(const POSIXThread&) {};
    POSIXThread& operator=(const POSIXThread&) { return *this; }

    virtual void execute()=0;
    static  void* threadFunction(void *);

    void    run();
    void    detach(void) const;
    void    yield(void)  const;

    bool    setPriority(int priority);
    int     getPriority();


   private:
    pthread_t    threadID;
    int          currentState;

};

#endif
